import { Flags } from "@siteimprove/alfa-flags";
import type { Hash } from "@siteimprove/alfa-hash";
import { type Parser as CSSParser } from "../../syntax/index.js";
import type { Resolvable } from "../resolvable.js";
import { Value } from "../value.js";
declare const TFlags: {
    of: (...flags: import("@siteimprove/alfa-array").Array<0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner">) => {
        has(flag: 0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner"): boolean;
        isSet: (flag: 0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner") => boolean;
        add(...flags: import("@siteimprove/alfa-array").Array<0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner">): any;
        set: (...flags: import("@siteimprove/alfa-array").Array<0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner">) => any;
        remove(...flags: import("@siteimprove/alfa-array").Array<0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner">): any;
        unset: (...flags: import("@siteimprove/alfa-array").Array<0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner">) => any;
        is(...flags: import("@siteimprove/alfa-array").Array<0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner">): boolean;
        equals(value: any): boolean;
        equals(value: unknown): value is any;
        toString(): string;
        toJSON(): Flags.JSON<"trim"> & {
            "discard-before": boolean;
            "discard-after": boolean;
            "discard-inner": boolean;
        };
        readonly value: number;
        readonly kind: "trim";
    } & {
        "discard-before": boolean;
        "discard-after": boolean;
        "discard-inner": boolean;
    };
    readonly none: 0;
    readonly empty: {
        has(flag: 0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner"): boolean;
        isSet: (flag: 0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner") => boolean;
        add(...flags: import("@siteimprove/alfa-array").Array<0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner">): any;
        set: (...flags: import("@siteimprove/alfa-array").Array<0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner">) => any;
        remove(...flags: import("@siteimprove/alfa-array").Array<0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner">): any;
        unset: (...flags: import("@siteimprove/alfa-array").Array<0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner">) => any;
        is(...flags: import("@siteimprove/alfa-array").Array<0 | 1 | 2 | 4 | "discard-before" | "discard-after" | "discard-inner">): boolean;
        equals(value: any): boolean;
        equals(value: unknown): value is any;
        toString(): string;
        toJSON(): Flags.JSON<"trim"> & {
            "discard-before": boolean;
            "discard-after": boolean;
            "discard-inner": boolean;
        };
        readonly value: number;
        readonly kind: "trim";
    } & {
        "discard-before": boolean;
        "discard-after": boolean;
        "discard-inner": boolean;
    };
    readonly allFlags: [1, 2, 4];
    nameOf: (flag: 1 | 2 | 4) => "discard-before" | "discard-after" | "discard-inner";
    reduce: (...flags: import("@siteimprove/alfa-array").Array<number>) => number;
    named: <K extends string, A extends import("@siteimprove/alfa-array").Array<string>>(kind: K, ...flags: A) => {
        [x: string]: any;
    };
    "discard-before": 1 | 2 | 4;
    "discard-after": 1 | 2 | 4;
    "discard-inner": 1 | 2 | 4;
};
type TFlags = ReturnType<(typeof TFlags)["of"]>;
/**
 * @public
 */
export declare class TrimFlags extends Value<"trim-flags", false> implements Resolvable<TrimFlags, never> {
    static of(flags: TFlags): TrimFlags;
    private readonly _flags;
    protected constructor(flags: TFlags);
    get discardBefore(): boolean;
    get discardAfter(): boolean;
    get discardInner(): boolean;
    resolve(): this;
    equals(value: unknown): value is this;
    hash(hash: Hash): void;
    toJSON(): TrimFlags.JSON;
    toString(): string;
}
/**
 * @public
 */
export declare namespace TrimFlags {
    interface JSON extends Value.JSON<"trim-flags"> {
        "discard-before": boolean;
        "discard-after": boolean;
        "discard-inner": boolean;
    }
    function isTrimFlags(value: unknown): value is TrimFlags;
    const parse: CSSParser<TrimFlags>;
}
export {};
//# sourceMappingURL=trim.d.ts.map