import type { Hash } from "@siteimprove/alfa-hash";
import type { Resolvable } from "../resolvable.js";
import { Value } from "../value.js";
/**
 * {@link https://developer.mozilla.org/en-US/docs/Web/CSS/ident}
 *
 * @public
 */
export declare abstract class Ident<T extends string = string, U extends string = string> extends Value<T, false> implements Resolvable<Ident, never> {
    protected readonly _value: U;
    protected constructor(type: T, value: U);
    get value(): U;
    is(...values: Array<string>): boolean;
    resolve(): Ident<T, U>;
    equals(value: unknown): value is this;
    hash(hash: Hash): void;
    toJSON(): Ident.JSON<T, U>;
    toString(): U;
}
/**
 * @public
 */
export declare namespace Ident {
    interface JSON<T extends string = string, U extends string = string> extends Value.JSON<T> {
        value: U;
    }
    function isIdent(value: unknown): value is Ident;
}
//# sourceMappingURL=ident.d.ts.map